"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.execute = exports.ENTRY_POINT_STORAGE = exports.Job = void 0;
const FS = require("fs");
const rxjs_1 = require("rxjs");
const operators_1 = require("rxjs/operators");
const devKitCore = require("@angular-devkit/core");
const architect_1 = require("@angular-devkit/architect");
const build_angular_1 = require("@angular-devkit/build-angular");
const ngPackagr = require("ng-packagr");
const create_hook_provider_1 = require("./create-hook-provider");
const utils_1 = require("./utils");
const hook_registry_1 = require("./hook-registry");
__exportStar(require("./hooks"), exports);
__exportStar(require("./hook-registry"), exports);
var job_1 = require("./job");
Object.defineProperty(exports, "Job", { enumerable: true, get: function () { return job_1.Job; } });
var utils_2 = require("./utils");
Object.defineProperty(exports, "ENTRY_POINT_STORAGE", { enumerable: true, get: function () { return utils_2.ENTRY_POINT_STORAGE; } });
const DEFAULT_TSCONFIG_OPTIONS = {
    moduleResolution: 'node',
    module: 'commonjs',
    target: 'es6',
    lib: [
        'es2017',
        'dom'
    ],
};
function buildRegistry(globalTasksContext) {
    return __awaiter(this, void 0, void 0, function* () {
        const root = globalTasksContext.root;
        const { tasks } = globalTasksContext.options;
        const transformerPath = tasks.config;
        const tPath = devKitCore.getSystemPath(devKitCore.resolve(root, devKitCore.normalize(transformerPath)));
        if (FS.existsSync(tPath)) {
            if (/\.ts$/.test(tPath) && !require.extensions['.ts']) {
                const tsNodeOptions = {};
                if (tasks.tsConfig) {
                    tsNodeOptions.project = tasks.tsConfig;
                }
                else {
                    tsNodeOptions.compilerOptions = DEFAULT_TSCONFIG_OPTIONS;
                }
                require('ts-node').register(tsNodeOptions);
            }
            const transformHooksModule = require(tPath);
            if (typeof transformHooksModule === 'function') {
                const registry = new hook_registry_1.HookRegistry();
                yield transformHooksModule(globalTasksContext, registry);
                return registry;
            }
            else {
                const registry = new hook_registry_1.HookRegistry(transformHooksModule);
                return registry;
            }
        }
        ;
        return Promise.resolve(new hook_registry_1.HookRegistry());
    });
}
function initRegistry(options, builderContext) {
    return __awaiter(this, void 0, void 0, function* () {
        const context = yield (0, utils_1.createHooksContext)(options, builderContext);
        const registry = yield buildRegistry(context);
        return { context, registry };
    });
}
function execute(options, context) {
    const { build, watch } = ngPackagr.NgPackagr.prototype;
    return (0, rxjs_1.from)(initRegistry(options, context))
        .pipe((0, operators_1.switchMap)(result => (0, utils_1.validateTypedTasks)(result.registry.getJobs(), result.context).then(() => result)), (0, operators_1.tap)(result => {
        const providers = (0, create_hook_provider_1.createHookProviders)(result.registry.getHooks(), result.context);
        ngPackagr.NgPackagr.prototype.build = function () {
            this.withProviders(providers);
            return build.call(this);
        };
        ngPackagr.NgPackagr.prototype.watch = function () {
            this.withProviders(providers);
            if (result.registry.hasSelfWatchJob) {
                return this.buildAsObservable();
            }
            else {
                return watch.call(this);
            }
        };
    }), (0, operators_1.switchMap)(() => (0, build_angular_1.executeNgPackagrBuilder)(options, context)), (0, operators_1.tap)(buildEvent => {
        ngPackagr.NgPackagr.prototype.build = build;
        ngPackagr.NgPackagr.prototype.watch = watch;
    }));
}
exports.execute = execute;
exports.default = (0, architect_1.createBuilder)(execute);
//# sourceMappingURL=index.js.map