import { virtualFs } from '@angular-devkit/core';
import { NgPackagrBuilderOptions } from '@angular-devkit/build-angular';
import { BuilderContext } from '@angular-devkit/architect';
import { TransformProvider } from 'ng-packagr/lib/graph/transform.di';
import { EntryPointNode } from 'ng-packagr/lib/ng-package/nodes';
import { NgPackagerHooksContext } from './hooks';
import { NgPackagerHooks, NgPackagrBuilderTaskOptions, NgPackagrBuilderTaskSchema, TaskPhases, NormalizedNgPackagerHooks, NormalizedTaskPhases } from './hooks';
import { JobMetadata } from './job';
export declare const TRANSFORM_PROVIDER_MAP: Record<keyof NgPackagerHooks, TransformProvider>;
export declare const HOOK_PHASES: (keyof TaskPhases<import("./hooks").EntryPointTaskContext<any[], NgPackagrBuilderTaskSchema>>)[];
export declare function normalizeHooks(hooks: NgPackagerHooks): NormalizedNgPackagerHooks;
export declare function normalizeTaskPhases(taskPhases: TaskPhases<any>): NormalizedTaskPhases;
export declare function getTaskDataInput<T>(jobMeta: JobMetadata, tasks: NgPackagrBuilderTaskOptions<NgPackagrBuilderTaskSchema>): {
    [x: string]: any;
};
export declare function validateTypedTasks(jobs: JobMetadata[], context: NgPackagerHooksContext): Promise<void>;
export interface EntryPointStorage {
}
export declare const ENTRY_POINT_STORAGE: {
    ENTRY_POINT_DATA: WeakMap<EntryPointNode, EntryPointStorage>;
    get(node: EntryPointNode): EntryPointStorage | undefined;
    merge(node: EntryPointNode, data: Partial<EntryPointStorage>): void;
    delete(node: EntryPointNode): boolean;
};
export declare function createHooksContext(options: NgPackagrBuilderOptions, context: BuilderContext, host?: virtualFs.Host<{}>): Promise<NgPackagerHooksContext>;
//# sourceMappingURL=utils.d.ts.map