"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ngCompilerCli = void 0;
function ngCompilerCli() {
    return __awaiter(this, void 0, void 0, function* () {
        // This uses a dynamic import to load `@angular/compiler-cli` which may be ESM.
        // CommonJS code can load ESM code via a dynamic import. Unfortunately, TypeScript
        // will currently, unconditionally downlevel dynamic import into a require call.
        // require calls cannot load ESM code and will result in a runtime error. To workaround
        // this, a Function constructor is used to prevent TypeScript from changing the dynamic import.
        // Once TypeScript provides support for keeping the dynamic import this workaround can
        // be dropped.
        // Follow https://github.com/ng-packagr/ng-packagr/blob/8842ae3eb71747513bdea1a49f315ecabd012467/src/lib/utils/ng-compiler-cli.ts
        const compilerCliModule = yield new Function(`return import('@angular/compiler-cli');`)();
        // If it is not ESM then the functions needed will be stored in the `default` property.
        // This conditional can be removed when `@angular/compiler-cli` is ESM only.
        return compilerCliModule.readConfiguration ? compilerCliModule : compilerCliModule.default;
    });
}
exports.ngCompilerCli = ngCompilerCli;
//# sourceMappingURL=ngc-cli-utils.js.map